#define DllExport extern "C" __declspec (dllexport)

#include <windows.h>
#include <stdio.h>
#include <vfw.h>

#define	IMAGEWIDTH(lpd)  ((LPBITMAPINFOHEADER)lpd)->biWidth
#define	IMAGEHEIGHT(lpd) ((LPBITMAPINFOHEADER)lpd)->biHeight
#define	IMAGEBITS(lpd)   ((LPBITMAPINFOHEADER)lpd)->biBitCount


LPVOID imageData = 0;
LPVOID imageData2 = 0;
int vfs = 0;


void SetImageData(LPVOID data)
{
  CopyMemory(((LPBYTE)imageData)+vfs,
	     data, 
	     IMAGEWIDTH(imageData)*IMAGEHEIGHT(imageData)*IMAGEBITS(imageData)/8);
}


LRESULT PASCAL _grabber_CallbackProc(HWND hWnd, LPVIDEOHDR lpVHdr)
{
  SetImageData(lpVHdr->lpData);

  return 0;
}



void update_buffer_size(HWND hwnd)
{
  vfs = capGetVideoFormatSize(hwnd);

  if(!vfs) {
    if(imageData) {
      HGLOBAL hg = GlobalHandle(imageData);
      GlobalUnlock(hg);
      GlobalFree(hg);
    }
    if(imageData2) {
      HGLOBAL hg = GlobalHandle(imageData2);
      GlobalUnlock(hg);
      GlobalFree(hg);
    }
    vfs = 0;
    imageData = NULL;
    imageData2 = NULL;

    return;		
  }

  DWORD	lastBufferSize=0;
  if (imageData) {
    lastBufferSize = vfs + IMAGEWIDTH(imageData)*IMAGEHEIGHT(imageData)*IMAGEBITS(imageData)/8;
  }
	
  DWORD newBufferSize;	

  BITMAPINFO *lpBmpInfo =(BITMAPINFO	*)( new char[vfs]);
	
  ((LPBITMAPINFOHEADER)lpBmpInfo)->biSize = sizeof BITMAPINFOHEADER;
	
  if(!capGetVideoFormat(hwnd, lpBmpInfo, (WORD)vfs)) {
    delete lpBmpInfo;
		
    if (imageData) {
      HGLOBAL hg = GlobalHandle(imageData);
      GlobalUnlock(hg);
      GlobalFree(hg);
    }
    if (imageData2) {
      HGLOBAL hg = GlobalHandle(imageData2);
      GlobalUnlock(hg);
      GlobalFree(hg);
    }
    vfs = 0;
    imageData = NULL;
    imageData2 = NULL;

    return;		
  }

  newBufferSize = vfs + IMAGEWIDTH(lpBmpInfo)*IMAGEHEIGHT(lpBmpInfo)*IMAGEBITS(lpBmpInfo)/8;
	
  SetWindowPos(hwnd, NULL,0,0,IMAGEWIDTH(lpBmpInfo),IMAGEHEIGHT(lpBmpInfo),
	       SWP_NOMOVE|SWP_NOZORDER);

  if(newBufferSize > lastBufferSize) {
    if (imageData) { //reallocate
      HGLOBAL hg = GlobalHandle(imageData);
      GlobalUnlock(hg);
      GlobalFree(hg);
    }
    if(imageData2) { //reallocate
      HGLOBAL hg = GlobalHandle(imageData2);
      GlobalUnlock(hg);
      GlobalFree(hg);
    }

    imageData  = GlobalLock(GlobalAlloc(GMEM_MOVEABLE, newBufferSize+256/*add 256 bytes, just in case...*/));
    imageData2 = GlobalLock(GlobalAlloc(GMEM_MOVEABLE, newBufferSize+256/*add 256 bytes, just in case...*/));
  }

  memcpy(imageData, lpBmpInfo, vfs);
  memcpy(imageData2, lpBmpInfo, vfs);
	
  delete lpBmpInfo;
}


DllExport POINT GetImageSize(HWND hwnd)
{
  POINT p;
  update_buffer_size(hwnd);

  if (!imageData) {
    p.x = 0;
    p.y = 0;
  }
  else {
    p.x = IMAGEWIDTH(imageData);
    p.y = IMAGEHEIGHT(imageData);
  }

  return p;
}



DllExport BOOL GetBits(void *bits)
{
  int c1 = 0, c2 = 0, c3 = 0, c4;
	
  if (IMAGEBITS(imageData) == 24) {
    c3 = IMAGEWIDTH(imageData)*IMAGEHEIGHT(imageData)*3;

    for (int y = 0; y < IMAGEHEIGHT(imageData); y++) {
      c3 = c3 - IMAGEWIDTH(imageData)*3;
      c4 = c1;
      for (int x = 0; x < IMAGEWIDTH(imageData); x++) {
	*((LPBYTE)bits+c1+c2) = *((LPBYTE)imageData+c1+c3-c4+vfs);
	c1++;
	*((LPBYTE)bits+c1+c2) = *((LPBYTE)imageData+c1+c3-c4+vfs);
	c1++;
	*((LPBYTE)bits+c1+c2) = *((LPBYTE)imageData+c1+c3-c4+vfs);
	c2++;
	*((LPBYTE)bits+c1+c2) = 255;
	c1++;
      }
    }

    return true;
  }

  if (IMAGEBITS(imageData) == 16) {
    c3 = IMAGEWIDTH(imageData)*IMAGEHEIGHT(imageData)*2;

    for (int y = 0; y < IMAGEHEIGHT(imageData); y++) {
      c3 = c3 - IMAGEWIDTH(imageData)*2;
      c4 = c1;
      for (int x = 0; x < IMAGEWIDTH(imageData); x++) {
	int a = *((LPBYTE)imageData+c1+c3-c4+vfs);
	int b = *((LPBYTE)imageData+c1+1+c3-c4+vfs);
	*((LPBYTE)bits+c1+c2) = ((a << 3));
	*((LPBYTE)bits+c1+1+c2) = ((b & 0x3) << 6) + ((a >> 5) << 3);
	*((LPBYTE)bits+c1+2+c2) = ((b & 0x7C) << 1);
	*((LPBYTE)bits+c1+3+c2) = 255;
	c2+=2;
	c1+=2;
      }
    }

    return true;
  }

  return false;
}


DllExport HWND StartCamera(HWND window, int device)
{
  HWND hWnd=capCreateCaptureWindow("WebCam",
				   WS_CHILD|WS_CLIPSIBLINGS, 0, 0, 160, 120, 
				   window, 0xffff);
  if(!hWnd)
    return 0;
		
  //initial setup for capture
  if(!capDriverConnect(hWnd, device)||
     !capSetCallbackOnFrame(hWnd, _grabber_CallbackProc)||
     !capPreview(hWnd, FALSE)) {	
    DestroyWindow(hWnd);
    return 0;
  }
  update_buffer_size(hWnd);

  return hWnd;
}
